/**********************************************************************************************/
/* VDK_DescriptionFile.h																	  */
/*                                                                       					  */
/* Valentina SDK    																		  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved                                                   					  */
/**********************************************************************************************/

#ifndef __VDK_DescriptionFile_h 
	#define __VDK_DescriptionFile_h
	
#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL.h>
#else
#	include <FBL.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class FBL_FileStream;


/**********************************************************************************************/
class VDK_DescriptionFile 
{
	protected://////////////////////////////////////////////////////////////////////////////////

		friend class VDK_DataBase;

		// Ctors are protected.
		// You must create it via VDK_DataBase::GetDescriptionFile();

								VDK_DescriptionFile( void ) {}
FBL_EXP							VDK_DescriptionFile( FBL_FileStream* inStream );

	public://///////////////////////////////////////////////////////////////////////////////////

FBL_EXP virtual					~VDK_DescriptionFile( void );

		// Write operations:

FBL_EXP	VDK_DescriptionFile&	operator << (const uchar* inString); // Pascal string
FBL_EXP	VDK_DescriptionFile&	operator << (const char* inString);
FBL_EXP	VDK_DescriptionFile&	operator << (char inNum);
FBL_EXP	VDK_DescriptionFile&	operator << (uchar inNum);
FBL_EXP	VDK_DescriptionFile&	operator << (short inNum);
FBL_EXP	VDK_DescriptionFile&	operator << (ushort inNum);
FBL_EXP	VDK_DescriptionFile&	operator << (long inNum);
FBL_EXP	VDK_DescriptionFile&	operator << (ulong inNum);
FBL_EXP	VDK_DescriptionFile&	operator << (float inNum);
FBL_EXP	VDK_DescriptionFile&	operator << (double inNum);		
FBL_EXP	VDK_DescriptionFile&	operator << (bool inBool);

		// Read Operations:
								
FBL_EXP	VDK_DescriptionFile&	operator >> (Str255 outString);	// Pascal string
FBL_EXP	VDK_DescriptionFile&	operator >> (char* outString);
FBL_EXP	VDK_DescriptionFile&	operator >> (char &outNum);
FBL_EXP	VDK_DescriptionFile&	operator >> (uchar &outNum);	
FBL_EXP	VDK_DescriptionFile&	operator >> (short &outNum);
FBL_EXP	VDK_DescriptionFile&	operator >> (ushort &outNum);
FBL_EXP	VDK_DescriptionFile&	operator >> (long &outNum);
FBL_EXP	VDK_DescriptionFile&	operator >> (ulong &outNum);
FBL_EXP	VDK_DescriptionFile&	operator >> (float &outNum);
FBL_EXP	VDK_DescriptionFile&	operator >> (double &outNum);		
FBL_EXP	VDK_DescriptionFile&	operator >> (bool &outBool);

	protected://////////////////////////////////////////////////////////////////////////////////
	
		FBL_FileStream*			mImplementation;		


	public://///////////////////////////////////////////////////////////////////////////////////
 
 		// These 2 data members allows easy to use VSDK to develop plugins
		// such as Valentina for REALbasic, Valentina for Java, which do have garbage collection.
			
			// An owner should set up this back reference, so when destructor of this class
			// will be called FROM kernel it will set back ref to NULL via mBackRef. 
			// The owner will be able to handle correctly this situation and won't try access
			// already destroyed kernel object.
		VDK_DescriptionFile**	mBackRef;
				
			// here you can put pointer on your own additional data (or even structure)
			// if you need attach several variables to this C++ instance.	
		void*					mXtraData;	

			// Destructor ~VDK_DescriptionFile() will call this pointer if you set it.
		void					(*mpFinalize)( VDK_DescriptionFile* inDataBase );
}; 


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif  


