/**********************************************************************************************/
/* VDK_Globals.h																			  */
/*                                                                       					  */
/* Valentina SDK    																		  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved                                                   					  */
/**********************************************************************************************/

#ifndef __VDK_Globals_h 
	#define __VDK_Globals_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL.h>
#else
#	include <FBL.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class VDK_Field;
class FBL_Set;


/**********************************************************************************************/
FBL_EXP 
VDK_Field* VDK_NewField( const char* inName, uchar inType );
// for application with dynamic structure.
// Create field of specified type and returns it.


/**********************************************************************************************/
// Next methods are executed in the current thread.
// So if you need 

FBL_EXP void VDK_Replace( VDK_Field* inField, const void* inNewValue, FBL_Set* inSet, bool inOwnsSet );

FBL_EXP double VDK_Sum( VDK_Field* inField, FBL_Set* inSet, bool inOwnsSet );
FBL_EXP double VDK_Avg( VDK_Field* inField, FBL_Set* inSet, bool inOwnsSet );
FBL_EXP double VDK_Min( VDK_Field* inField, FBL_Set* inSet, bool inOwnsSet );
FBL_EXP double VDK_Max( VDK_Field* inField, FBL_Set* inSet, bool inOwnsSet );
	
	
/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif  
