/**********************************************************************************************/
/* VDK_Time.h																				  */
/*                                                                       					  */
/* Valentina SDK    																		  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved                                                   					  */
/**********************************************************************************************/

#ifndef __VDK_Time_h 
	#define __VDK_Time_h
	
#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/VDK_Field.h>
#	include <VSDK/FBL_DateTimeEncode.h>
#else
#	include <VDK_Field.h>
#	include <FBL_DateTimeEncode.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class FBL_EXP VDK_Time : public virtual VDK_Field
{
	public://///////////////////////////////////////////////////////////////////////////////////
		
FBL_EXP							VDK_Time( const char* inName, ushort inFlags = 0 );
								
virtual							~VDK_Time( void ) {}
		
		/* unified interface: */
	
FBL_EXP	virtual void			Set( ushort inHour,   ushort inMinute,   ushort inSecond );
FBL_EXP	virtual void			Get( ushort& outHour, ushort& outMinute, ushort& outSecond ) const;				

		FBL_BitSet*				Find( const ulong* inLeftValue , bool inLeftInclude, 
									  const ulong* inRightValue, bool inRightInclude ) 
								{
									return VDK_Field::Find( inLeftValue,  inLeftInclude,
															inRightValue, inRightInclude );
								}
		
		FBL_BitSet* 			Find( const ulong* inKey = NULL )	{
									return VDK_Field::Find( inKey );
								}

}; 


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif  

