/**********************************************************************************************/
/* VDK_VarChar.h																			  */
/*                                                                       					  */
/* Valentina SDK    																		  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved                                                   					  */
/**********************************************************************************************/

#ifndef __VDK_VarChar_h 
	#define __VDK_VarChar_h
	
#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/VDK_String.h>
#	include <VSDK/FBL_StringUtilities.h>
#else
#	include <VDK_String.h>
#	include <FBL_StringUtilities.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
// Valentina store strings in the indexes as varaible length pascal strings always.

// VDK_String 	stores strings in the table as fixed length strings
// VDK_VarChar 	stores strings in the tables as variable length strings.
// VDK_Text 	stores strings as BLOB objects (also variable length, based on segments).
// VDK_Byte 	is most effective to store strings with length 1 character.

/**********************************************************************************************/
class FBL_EXP VDK_VarChar : public virtual VDK_String
{
		friend class VDK_BaseObject;

	public://///////////////////////////////////////////////////////////////////////////////////
		
FBL_EXP	explicit				VDK_VarChar( 
									const char* inName, 
									ushort		inMaxLen	= 504, 
									const char*	inLanguage	= NULL, 
									ushort		inFlags		= 0 );
									
FBL_EXP virtual void           	operator= ( const char* inValue ) {
									VDK_String::operator=( inValue );
								}
								
FBL_EXP virtual             	operator const char*( void ) const{
									return VDK_String::operator const char*();
								}

	protected://////////////////////////////////////////////////////////////////////////////////

FBL_EXP virtual void			FinishCreateSelf( void );

}; 


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif  


